#!/usr/bin/python
# Festival Speech Synthesizer GUI
#
# Author: Graham Morrison for Linux Format issue LXF109
#
# A script that links to a simple Qt GUI and Qt Phonon to playback the ouput from the
# Festival speech synthesizer. Festival needs to be running in server mode:
# (festival --server).

import sys, os,tempfile, time
from PyQt4 import QtCore, QtGui
from PyQt4.phonon import Phonon
from ui_fooey import Ui_MainWindow


class StartQT4(QtGui.QMainWindow):
	def __init__(self, parent=None):
		QtGui.QWidget.__init__(self, parent)
		self.ui = Ui_MainWindow()
		self.ui.setupUi(self)

		self.audioOutput = Phonon.AudioOutput(Phonon.MusicCategory, self)
		self.metaInformationResolver = Phonon.MediaObject(self)
		self.mediaObject = Phonon.MediaObject(self)	

		self.ui.seekSlider.setMediaObject(self.mediaObject)
		
		Phonon.createPath(self.mediaObject, self.audioOutput)
		
		self.connect(self.ui.pushButton2, QtCore.SIGNAL('pressed()'), self.mediaObject, QtCore.SLOT('stop()'))
		self.connect(self.ui.pushButton1, QtCore.SIGNAL('pressed()'), self.playPause)

	def playPause(self):
		if self.mediaObject.state() == Phonon.PlayingState:
			self.mediaObject.pause()
		elif self.mediaObject.state() == Phonon.PausedState:
			self.mediaObject.play()
		else:
			os.popen('echo "' + str(self.ui.textEdit.toPlainText()) + '" | festival_client --ttw > ' + tmpfile, "r")
			time.sleep(0.2)
			self.mediaObject.setCurrentSource(Phonon.MediaSource(str(tmpfile)))
			self.mediaObject.play()

if __name__ == "__main__":
	app = QtGui.QApplication(sys.argv)
	waveform = QtCore.QBuffer()
	app.setApplicationName("Speech Synth")
	
	tmpfile = tempfile.mktemp(suffix='.wav')
	os.popen('touch ' + tmpfile)
	
	myapp = StartQT4()
	myapp.show()
	
	try:
		sys.exit(app.exec_())
	except SystemExit:
		pass
	
	os.remove(tmpfile) 
	
